<script lang="ts">
    import { Card } from 'flowbite-svelte';
    import { blogPosts } from '$lib/data/blog-data';
    
    // Sort posts by date in descending order
    const sortedPosts = [...blogPosts].sort((a, b) => {
        return new Date(b.date).getTime() - new Date(a.date).getTime();
    });

    // Get unique tags from all posts
    const allTags = [...new Set(
        blogPosts.flatMap(post => post.tags)
    )].sort();

    // Selected tags for filtering
    let selectedTags: string[] = [];

    // Filter posts based on selected tags
    $: filteredPosts = selectedTags.length > 0
        ? sortedPosts.filter(post =>
            selectedTags.some(tag => post.tags.includes(tag))
          )
        : sortedPosts;

    // Group posts by year
    $: postsByYear = sortedPosts.reduce((acc, post) => {
        const year = new Date(post.date).getFullYear();
        if (!acc[year]) {
            acc[year] = [];
        }
        acc[year].push(post);
        return acc;
    }, {} as Record<number, typeof blogPosts>);

    // Get years in descending order
    $: years = Object.keys(postsByYear)
        .map(Number)
        .sort((a, b) => b - a);

    // Toggle tag selection
    function toggleTag(tag: string) {
        selectedTags = selectedTags.includes(tag)
            ? selectedTags.filter(t => t !== tag)
            : [...selectedTags, tag];
    }

    function formatDate(dateString: string) {
        const date = new Date(dateString);
        return date.toLocaleDateString('en-US', {
            year: 'numeric',
            month: 'long',
            day: 'numeric'
        });
    }
</script>

<div class="container mx-auto px-4 py-8">
    <h1 class="text-3xl font-bold mb-8">Blog Posts</h1>
    
    <div class="lg:grid lg:grid-cols-12 lg:gap-8">
        <!-- Main content -->
        <div class="lg:col-span-8">
            <!-- Results count when filtering -->
            {#if selectedTags.length > 0}
                <div class="mb-6 text-gray-600">
                    Showing {filteredPosts.length} post{filteredPosts.length === 1 ? '' : 's'} 
                    with selected tags
                    <button 
                        class="text-blue-600 hover:text-blue-800 ml-2 underline"
                        on:click={() => selectedTags = []}
                    >
                        Clear filters
                    </button>
                </div>
            {/if}
            
            <!-- Posts list -->
            <div class="divide-y divide-gray-200">
                {#each filteredPosts as post}
                    <article class="py-6 hover:bg-gray-100">
                        <div class="space-y-2">
                            <div class="text-xs text-gray-500">
                                {formatDate(post.date)}
                            </div>
                            
                            <h2 class="text-2xl font-bold">
                                <a 
                                    href="/blog/{post.id}" 
                                    class="hover:text-blue-600 transition-colors"
                                >
                                    {post.title}
                                </a>
                            </h2>
                            
                            <div class="flex items-center gap-2 text-sm">
                                <span class="font-medium">By {post.author}</span>
                            </div>
                            
                            <p class="text-gray-600">
                                {post.summary}
                            </p>
                            
                            <div class="flex gap-2">
                                {#each post.tags as tag}
                                    <button
                                        class="inline-flex items-center px-2.5 py-0.5 rounded-full text-xs font-medium
                                            {selectedTags.includes(tag)
                                                ? 'bg-blue-600 text-white'
                                                : 'bg-blue-100 text-blue-800 hover:bg-blue-200'}"
                                        on:click={() => toggleTag(tag)}
                                    >
                                        {tag}
                                    </button>
                                {/each}
                            </div>
                        </div>
                    </article>
                {/each}

                {#if filteredPosts.length === 0}
                    <div class="py-8 text-center text-gray-500">
                        No posts found with the selected tags.
                        <button 
                            class="text-blue-600 hover:text-blue-800 block mx-auto mt-2"
                            on:click={() => selectedTags = []}
                        >
                            Clear filters
                        </button>
                    </div>
                {/if}
            </div>
        </div>

        <!-- Sidebar -->
        <div class="lg:col-span-4 mt-8 lg:mt-0">
            <div class="sticky top-8 space-y-6">
                <!-- Tag filters moved to sidebar -->
                <Card class="!w-full">
                    <h2 class="text-xl font-semibold mb-4">Filter by Tags</h2>
                    <div class="flex flex-wrap gap-2">
                        {#each allTags as tag}
                            <button
                                class="px-3 py-1 rounded-full text-sm font-medium transition-colors
                                    {selectedTags.includes(tag) 
                                        ? 'bg-blue-600 text-white'
                                        : 'bg-blue-100 text-blue-800 hover:bg-blue-200'}"
                                on:click={() => toggleTag(tag)}
                            >
                                {tag}
                                {#if selectedTags.includes(tag)}
                                    <span class="ml-1">×</span>
                                {/if}
                            </button>
                        {/each}
                    </div>
                </Card>

                <!-- Posts by year -->
                <Card class="!w-full">
                    <h2 class="text-xl font-semibold mb-4">Posts by Year</h2>
                    <div class="space-y-4">
                        {#each years as year}
                            <div>
                                <h3 class="text-lg font-medium text-gray-900 mb-2">{year}</h3>
                                <ul class="space-y-2">
                                    {#each postsByYear[year] as post}
                                        <li>
                                            <a 
                                                href="/blog/{post.id}"
                                                class="text-gray-600 hover:text-blue-600 transition-colors block"
                                            >
                                                {post.title}
                                            </a>
                                        </li>
                                    {/each}
                                </ul>
                            </div>
                        {/each}
                    </div>
                </Card>
            </div>
        </div>
    </div>
</div>